<?php
/* 
Plugin Name: WP 2.5 Gallery Validation Plugin
Plugin URI: http://www.fob-marketing.de/marketing-blog-647-wordpress-25-gallery-validation-plugin.html
Description: Valid XHTML for your WordPress 2.5 Gallery. 
Version: 0.2 
Author: Oliver Bockelmann (fob marketing) 
Author URI: http://www.fob-marketing.de/ 
Update Server: 
Min WP Version: 2.5 
Max WP Version: 2.5 
*/


/*

** WP 2.5 Gallery Validation Plugin, 04-12-2008 | Copyright (c) 2008 fob marketing, Hamburg. 
** This plugin is free software. The plugin is provided "as is" without any warranty. 
** (GPL Software - See http://www.gnu.org/licenses/gpl.html for details.) 


== Plugin Features == 

    Validate your WordPress 2.5 Gallery (Check www.w3.org for validation errors) 

== Installation == 
 
    1. Upload the plugin folder to your `/wp-content/plugins/` directory 
    2. Activate the plugin through the 'Plugins' menu in WordPress 
    3. Modify the Plugin Code or CSS as you like 

    Enjoy! 


    Copyright 2008  F. Oliver Bockelmann (fob marketing, email : info@fob-marketing.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



// Use Stylesheet: 
add_action('wp_head', 'gallery_stylesheet_css'); 

function gallery_stylesheet_css() { 
echo '<!-- Generated by fob : WP 2.5 Gallery Validaton Plugin -->'."\n"; ?>
<link href="<?php bloginfo('wpurl') ?>/wp-content/plugins/fob-gallery-validator/fob-gallery-validation.css" rel="stylesheet" type="text/css" media="screen" />
<?php } 

function fob_gallery_style($attr) {
	global $post;

	if ( $output != '' )
		return $output;
	
// Do you want more or less or other containers? I thought divs should be good for everyone. 
// Use div or span or nothing ( '' ) as you like. The default should look like the original WordPress Gallery: 
// Have a look at the attached CSS file if it meets your requirements. It was made for use with thumbs of 100px up to 120px; 
	
	extract(shortcode_atts(array(
		'orderby'    => 'menu_order ASC, ID ASC',
		'id'         => $post->ID,
		'itemtag'    => 'div',
		'icontag'    => 'div',
		'captiontag' => 'div',
		'columns'    => 3,
		'size'       => 'thumbnail',
	), $attr));

	$id = intval($id);
	$orderby = addslashes($orderby);
	$attachments = get_children("post_parent=$id&post_type=attachment&post_mime_type=image&orderby=\"{$orderby}\"");
/* 
	// WP 2.5.1:
	// $attachments = get_children("post_parent=$id&post_type=attachment&post_mime_type=image&orderby={$orderby}");
*/ 

	if ( empty($attachments) )
		return '';

	if ( is_feed() ) {
		$output = "\n";
		foreach ( $attachments as $id => $attachment )
			$output .= wp_get_attachment_link($id, $size, true) . "\n";
		return $output;
	}

	$listtag = tag_escape($listtag);
	$itemtag = tag_escape($itemtag);
	$captiontag = tag_escape($captiontag);
	$columns = intval($columns);
	$itemwidth = $columns > 0 ? floor(100/$columns) : 100;
	
	$output = apply_filters('gallery_style', "<div class='gallery'>"); 

	foreach ( $attachments as $id => $attachment ) {
		$link = wp_get_attachment_link($id, $size, true);
		$output .= "<{$itemtag} class='gallery-item'>";
		$output .= "
			<{$icontag} class='gallery-icon'>
				$link
			</{$icontag}>";

/* 

// Don`t like to see CSS Code nor caption tags nor excerpts in Gallery Albums: 

		if ( $captiontag && trim($attachment->post_excerpt) ) {
			$output .= "
				<{$captiontag} class='gallery-caption'>
				{$attachment->post_excerpt}
				</{$captiontag}>";
		}

*/ 
		
		$output .= "</{$itemtag}>";
		
/* 

// Seems not to be necessary: 

		if ( $columns > 0 && ++$i % $columns == 0 )
			$output .= '<br style="clear: both" />';
*/ 
		
		}
	
// Clear floating behind the gallery pictures:

	$output .= "<br class='clear' /></div>";
	return $output;
}

remove_shortcode('gallery_shortcode');
remove_filter('post_gallery', ''); 
remove_filter('gallery_style', '');
remove_filter ('the_content', 'wpautop');
add_filter('post_gallery', 'fob_gallery_style'); 

?>